mod Ex03 logic: 'cl'

incl Mtex

incl Maux

incl Mprf

incl Mprt

loc rem 
  3. CVICENIE Z PREDMETU TEORIA VYPOCITATELNOSTI PRE PROGRAMATOROV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 6.10.2005
  ******************************************************************************
  PMAIL: comp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/comp
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
  ULOHY: 20%
  MIDTERM: 20%
  FINALTERM: 60%
  ******************************************************************************
  POCET BODOV ZA ULOHY V TOMTO SUBORE: 4 
  POCET BODOV ZA PREMIOVE ULOHY V TOMTO SUBORE: 2
  ******************************************************************************
  PRENOS: <cl>/4i/prenos/ex/ex03/<vase meno>/ex03.cl
          kde <cl> je adresar /data/VYUKA/INF/CL na barbie.nw.fmph.uniba.sk
          ************************************************
          *** odovzdat do 11.10.2005 (utorok) do 18:00 ***
          ************************************************
  ******************************************************************************

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane univerzalnej 
  funkcii pre primitivne rekurzivne funkcie. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subory \it  maux.cl  \end obsahuju definicie niektorych funkcii a 
         predikatov. 
   \item \para Subor \it  mprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mprt.cl  \end obsahuje aritmetizaciu p.r. termov. 
   \item \para Subor \it  ex03.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] Remark.  \end Catalan pairing function - see the module 
  \ft Maux \end. 

rem 
  \para \bf  [CL] Remark.  \end Clausal language is not allowed in definitions 
  of p.r. functions unless said otherwise. But you may use assignments in 
  definitions of constants. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion.  \end 

rem 
  \para \bf  Subsection. Universal Function for Primitive Recursive Functions is 
  not Primitive Recursive.  \end 

rem 
  \para \bf  Primitive recursive function symbols.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \ft Mprf \end. 

rem 
  \para \bf  Interpeter of primitive recursive functions.  \end \it  [Uloha (1 
  bod)]  \end 
  \para \it  Remark.  \end Clausal language allowed. 

fun/2 U 'Tex_f2_pr_u'
  U(e,x) = Foo

rem 
  \para \bf  Primitive recursive indices.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Xc1 'Tex_f1_pr_xc1' \end Define the 
  unary primitive recursive function \ft Xc1(m) \end satisfying 
  \eq* 
    U(Xc1(m),x) = m
  \end

fun Xc1 'Tex_f1_pr_xc1'
  Xc1(m) = Foo

thm Spec_xc1
  U(Xc1(m),x) = m

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xc2 'Tex_f2_pr_xc2' \end Define the 
  binary primitive recursive function \ft Xc2(n,m) \end satisfying 
  \eq* 
    U(Xc2(n,m),x1,Texm_f0_dotsc,Texm_f2_sub(x,n)) = m
  \end

fun/2 Xc2 'Tex_f2_pr_xc2'
  Xc2(n,m) = Foo

thm Spec_xc2_1
  U(Xc2(1,m),x1) = m

thm Spec_xc2_2
  U(Xc2(2,m),x1,x2) = m

thm Spec_xc2_3
  U(Xc2(3,m),x1,x2,x3) = m

thm Spec_xc2
  Tp(n,x) -> U(Xc2(n,m),x) = m

rem 
  \para \bf  Primitive recursive terms.  \end 

rem 
  \para \bf  Arithmetization of primitive recursive terms.  \end See also the 
  module \ft Mprt \end. 

rem 
  \para \bf  Denotation of primitive recursive terms.  \end 

fun/3 Den 'Tex_f3_pr_den'
  Den(n,Vt(i),v) = Sel(n,v,i)
  Den(n,Ct(m),v) = m
  Den(n,Pt(t,ts),v) = Den(n,t,v),Den(n,ts,v)
  Den(n,At(f,ts),v) = U(f,Den(n,ts,v))

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xedf 'Tex_f2_pr_xedf' \end 
  \header* fun/3 F 'Tex_f3_f' \end Define a binary primitive recursive function 
  \ft Xedf(n,t) \end such that 
  \items 
   \item \para for every \ft n >= 1 \end, if the number \ft t \end is the code 
         of a p.r. term 
         \ft Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n)) \end with all its 
         free variables indicated then the application \ft Xedf(n,t) \end yields 
         a p.r. index of the n-ary primitive recursive function 
         \ft Texm_f0_f \end explicitly defined by 
         \eq* 
           F(x1,Tex0_dotsc,Texm_f2_sub(x,n)) = 
           Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n))
         \end
         \para or equivalently, we wish to have 
         \eq* 
           U(Xedf(n,t),v) = Den(n,t,v)
         \end
         \para for every \ft n \end-tuple \ft v \end. 
  \end
  \para \it  Remark.  \end You may use clausal language in the definition. You 
  will need the unary function \ft Ar(f) \end yielding the arity of the function 
  symbol \ft f \end. The function is defined in the module \it  Mprf  \end. 

fun/2 Xedf 'Tex_f2_pr_xedf'
  Xedf(n,t) = Foo

lemma Lemma_spec_xedf
  Ft(t) -> U(Xedf(n,t),v) = Den(n,t,v)

thm Spec_xedf
  Prt(t,n) & n >= 1 -> U(Xedf(n,t),v) = Den(n,t,v)

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun Xiter 'Tex_f1_pr_xiter' \end Define a primitive recursive 
  function \ft Xiter(e) \end satisfying 
  \eq* 
    U(Xiter(e),0,x) = x
  \end
  \eq* 
    U(Xiter(e),n+1,x) = U(e,U(Xiter(e),n,x))
  \end
  \para In other words, if \ft e \end is a p.r. index of a unary function then 
  \ft Xiter(e) \end is a p.r. index of its iteration. 

fun Xiter 'Tex_f1_pr_xiter'
  Xiter(e) = Foo

thm Spec_xiter_zero
  U(Xiter(e),0,x) = x

thm Spec_xiter_succ
  U(Xiter(e),n+1,x) = U(e,U(Xiter(e),n,x))
proof  proved.

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xrec0 'Tex_f2_pr_xrec0' \end 
  \header* fun F 'Tex_f1_f' \end \header* fun/2 H 'Tex_f2_h' \end 
  \header* fun/0 M 'Tex_f0_m' \end Define a binary primitive recursive function 
  \ft Xrec0(m,e) \end satisfying 
  \eq* 
    U(Xrec0(m,e),0) = m
  \end
  \eq* 
    U(Xrec0(m,e),x+1) = U(e,x,U(Xrec0(m,e),x))
  \end
  \para In other words, if \ft M \end is a constant and \ft e \end is a p.r. 
  index of a binary function \ft H(x,a) \end then \ft Xrec0(m,e) \end is a p.r. 
  index of the unary function \ft F(x) \end defined by following parameterless 
  primitive recursion: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = M
    F(x+1) = H(x,F(x))
  \end

fun/2 Xrec0 'Tex_f2_pr_xrec0'
  Xrec0(m,e) = Foo

thm Spec_xrec0_zero
  U(Xrec0(m,e),0) = m

thm Spec_xrec0_succ
  U(Xrec0(m,e),x+1) = U(e,x,U(Xrec0(m,e),x))
proof  proved.

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/0 Xplus 'Tex_f0_pr_xplus' \end Find a p.r. index of the addition 
  function \ft x+y \end, ie find the number \ft Xplus \end such that 
  \eq* 
    U(Xplus,x,y) = x+y
  \end

fun/0 Xplus 'Tex_f0_pr_xplus'
  Xplus = Foo

thm Spec_xplus
  U(Xplus,x,y) = x+y

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xpred 'Tex_f0_pr_xpred' \end Find a 
  p.r. index of the predecessor function \ft x-1 \end, ie find the number 
  \ft Xpred \end such that 
  \eq* 
    U(Xpred,x) = x-1
  \end

fun/0 Xpred 'Tex_f0_pr_xpred'
  Xpred = Foo

thm Spec_xpred
  U(Xpred,x) = x-1

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xminus 'Tex_f0_pr_xminus' \end Find 
  a p.r. index of the modified subtraction function \ft x-y \end, ie find the 
  number \ft Xminus \end such that 
  \eq* 
    U(Xminus,x,y) = x-y
  \end

fun/0 Xminus 'Tex_f0_pr_xminus'
  Xminus = Foo

thm Spec_xminus
  U(Xminus,x,y) = x-y

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xd 'Tex_f0_pr_xd' \end Find a p.r. 
  index of the case discrimination function \ft D1(x,y,z) \end, ie find the 
  number \ft Xd \end such that 
  \eq* 
    U(Xd,x,y,z) = D1(x,y,z)
  \end

fun/0 Xd 'Tex_f0_pr_xd'
  Xd = Foo

thm Spec_xd
  U(Xd,x,y,z) = D1(x,y,z)

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/0 Xeqf 'Tex_f0_pr_xeqf' \end Find a p.r. index of the 
  characteristic function of the equality predicate \ft x = y \end, ie find the 
  number \ft Xeqf \end such that 
  \eq* 
    U(Xeqf,x,y) = Eqf(x,y)
  \end

fun/0 Xeqf 'Tex_f0_pr_xeqf'
  Xeqf = Foo

thm Spec_xeqf
  U(Xeqf,x,y) = Eqf(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xnotf 'Tex_f0_pr_xnotf' \end Find a 
  p.r. index of the negation boolean function \ft Notf(x) \end, ie find the 
  number \ft Xnotf \end such that 
  \eq* 
    U(Xnotf,x) = Notf(x)
  \end

fun/0 Xnotf 'Tex_f0_pr_xnotf'
  Xnotf = Foo

thm Spec_xnotf
  U(Xnotf,x) = Notf(x)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xandf 'Tex_f0_pr_xandf' \end Find a 
  p.r. index of the conjunction boolean function \ft Andf(x,y) \end, ie find the 
  number \ft Xandf \end such that 
  \eq* 
    U(Xandf,x,y) = Andf(x,y)
  \end

fun/0 Xandf 'Tex_f0_pr_xandf'
  Xandf = Foo

thm Spec_xandf
  U(Xandf,x,y) = Andf(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xlef 'Tex_f0_pr_xlef' \end Find a 
  p.r. index of the characteristic function of the predicate \ft x <= y \end, ie 
  find the number \ft Xlef \end such that 
  \eq* 
    U(Xlef,x,y) = Lef(x,y)
  \end

fun/0 Xlef 'Tex_f0_pr_xlef'
  Xlef = Foo

thm Spec_xlef
  U(Xlef,x,y) = Lef(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xltf 'Tex_f0_pr_xltf' \end Find a 
  p.r. index of the characteristic function of the predicate \ft x <= y \end, ie 
  find the number \ft Xltf \end such that 
  \eq* 
    U(Xltf,x,y) = Ltf(x,y)
  \end

fun/0 Xltf 'Tex_f0_pr_xltf'
  Xltf = Foo

thm Spec_xltf
  U(Xltf,x,y) = Ltf(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xtimes 'Tex_f0_pr_xtimes' \end Find 
  a p.r. index of the multiplication function \ft x*y \end, ie ie find the 
  number \ft Xtimes \end such that 
  \eq* 
    U(Xtimes,x,y) = x*y
  \end

fun/0 Xtimes 'Tex_f0_pr_xtimes'
  Xtimes = Foo

thm Spec_xtimes
  U(Xtimes,x,y) = x*y

rem 
  \para \bf  Exercise.  \end \header* fun/0 Xexp 'Tex_f0_pr_xexp' \end Find a 
  p.r. index of the exponentiation function \ft Exp(x,y) \end, ie find the 
  number \ft Xexp \end such that 
  \eq* 
    U(Xexp,x,y) = Exp(x,y)
  \end

fun/0 Xexp 'Tex_f0_pr_xexp'
  Xexp = Foo

thm Spec_xexp
  U(Xexp,x,y) = Exp(x,y)

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xparam 'Tex_f2_pr_xparam' \end 
  Define a binary primitive recursive function \ft Xparam(e,x) \end satisfying 
  \eq* 
    U(Xparam(e,x),y) = U(e,x,y)
  \end
  \para The function is called the parametric function. 

fun/2 Xparam 'Tex_f2_pr_xparam'
  Xparam(e,x) = Foo

thm Spec_xparam
  U(Xparam(e,x),y) = U(e,x,y)
proof  proved.

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun/3 Xsmn_2_3 'Tex_f3_pr_xsmn_2_3' \end Prove the Kleene's s-m-n 
  theorem for the case \ft m = 2 \end and \ft n = 3 \end by providing a ternary 
  primitive recursive function \ft Xsmn_2_3(e,x1,x2) \end satisfying 
  \eq* 
    U(Xsmn_2_3(e,x1,x2),y1,y2,y3) = U(e,x1,x2,y1,y2,y3)
  \end

fun/3 Xsmn_2_3 'Tex_f3_pr_xsmn_2_3'
  Xsmn_2_3(e,x1,x2) = Foo

thm Spec_xsmn_2_3
  U(Xsmn_2_3(e,x1,x2),y1,y2,y3) = U(e,x1,x2,y1,y2,y3)
proof  proved.

rem 
  \para \bf  Exercise.  \end \header* fun Xdiag 'Tex_f1_pr_xdiag' \end Define a 
  primitive recursive function \ft Xdiag(e) \end satisfying 
  \eq* 
    U(Xdiag(e),x) = U(e,x,x)
  \end
  \para In other words, if \ft e \end is a p.r. index of a binary function then 
  \ft Xdiag(e) \end is a p.r. index of its diagonalization. 

fun Xdiag 'Tex_f1_pr_xdiag'
  Xdiag(e) = Foo

thm Spec_xdiag
  U(Xdiag(e),x) = U(e,x,x)
proof  proved.

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Xcantor 'Tex_f0_pr_xcantor' \end 
  \header* fun Xu2 'Tex_f0_pr_xu2' \end Show that the binary function 
  \ft U(e,x) \end is not primitive recursive, that is 
  \eq* 
    ~\e e\a x\a y U(e,x,y) = U(x,y)
  \end
  \para or equivalently 
  \eq* 
    \a e\e x\e y U(e,x,y) != U(x,y)
  \end
  \para by providing a primitive recursive function \ft Xcantor(e) \end 
  satisfying 
  \eq* 
    U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))
  \end

fun Xcantor 'Tex_f0_pr_xcantor'
  Xcantor(e) = Foo

thm Spec_xcantor
  U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

